# coding: utf-8

"""
    HPE Machine Learning Inference Software (MLIS/Aioli)

    HPE MLIS is *Aioli* -- The AI On-line Inference Platform that enables easy deployment, tracking, and serving of your packaged models regardless of your preferred AI framework.

    The version of the OpenAPI document: 1.4.0-dev16
    Contact: community@determined-ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from aiolirest.models.role_assignment import RoleAssignment
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class RoleAssignments(BaseModel):
    """
    RoleAssignments describes the user-role assignments.
    """ # noqa: E501
    user_role_assignments: Optional[List[RoleAssignment]] = Field(default=None, description="the set of user and role assignment to be added.", alias="userRoleAssignments")
    __properties: ClassVar[List[str]] = ["userRoleAssignments"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of RoleAssignments from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in user_role_assignments (list)
        _items = []
        if self.user_role_assignments:
            for _item in self.user_role_assignments:
                if _item:
                    _items.append(_item.to_dict())
            _dict['userRoleAssignments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of RoleAssignments from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "userRoleAssignments": [RoleAssignment.from_dict(_item) for _item in obj.get("userRoleAssignments")] if obj.get("userRoleAssignments") is not None else None
        })
        return _obj


